<?php

namespace Modules\Cotacao\Modules\ListaPreco\Services;

use Doctrine\ORM\EntityManager;

class Sup01300VerificacaoListaPrecoService {
    
    protected $entityManager;
    protected $criptografia;

    public function __construct(EntityManager $entityManager) 
    {
        $this->entityManager = $entityManager;
    }

    public function updateItemcole($row) 
    {
        try {
            $sql = "UPDATE ITEMCOLE
                       SET ITEMCOLE.IDITMLISPREC = 'N'
                     WHERE ITEMCOLE.CDFILIAL = :P_CDFILIAL 
                       AND EXISTS (SELECT 1
                                     FROM PRODUTO
                                    WHERE PRODUTO.CDPRODUTO = ITEMCOLE.CDPRODUTO
                                      AND PRODUTO.CDARVPROD BETWEEN :P_CDINI AND :P_CDFIN) 
                       AND ((INSTR(:P_CDREGIAO, ITEMCOLE.CDREGIAO) > 0) OR (:P_CDREGIAO = 'T')) 
                       AND EXISTS (SELECT 1
                                     FROM COLETAPR
                                    WHERE COLETAPR.CDFILIAL = ITEMCOLE.CDFILIAL
                                      AND COLETAPR.NRCOLEPRECO = ITEMCOLE.NRCOLEPRECO) 
                       AND EXISTS (SELECT 1
                                     FROM PRODUTO, PRODUTO PR, PRODCOMP
                                    WHERE ((INSTR(:P_CDOPERADOR, PRODCOMP.CDOPERADOR) > 0) OR (:P_CDOPERADOR = 'T')) 
                                      AND ITEMCOLE.CDPRODUTO = PRODUTO.CDPRODUTO
                                      AND PR.CDPRODUTO = PRODCOMP.CDPRODUTO
                                      AND (PRODUTO.CDARVPROD LIKE PR.CDARVPROD || '%' OR PRODUTO.CDPRODESTO = PRODCOMP.CDPRODUTO)) 
                       AND ITEMCOLE.IDITMLISPREC = 'S'
                       AND ITEMCOLE.DTFINVALITM < SYSDATE";
            $params = array(
                "P_CDFILIAL"    => $row["CDFILIAL"],
                "P_CDINI"       => $row["CDPRODINI"],
                "P_CDFIN"       => self::strPadRigthProd($row['CDPRODFIN']),
                "P_CDREGIAO"    => $row["CDREGIAO"],
                "P_CDOPERADOR"  => $row["CDOPERADOR"]
            );
            $this->entityManager->getConnection()->executeUpdate($sql, $params);        
        } catch(\Exception $e) {
            throw $e;
        }
    }
   
	private function strPadRigthProd($value)
	{
		return str_pad($value, 20, 'Z', STR_PAD_RIGHT);
	}
    
    public function getCentralCompras($cdfilial) 
    {
        try {
            $sql = "SELECT NVL(FILIAL.CDFILCENTCMP, FILIAL.CDFILIAL) CDFILIAL
                      FROM FILIAL FIL, FILIAL
                     WHERE FILIAL.CDFILIAL = :P_CDFILIAL 
                       AND NVL(FILIAL.CDFILCENTCMP, FILIAL.CDFILIAL) = FIL.CDFILIAL";
            
            $query = $this->entityManager->getConnection()->prepare($sql);
            $query->execute(array(
                "P_CDFILIAL" => $cdfilial
            ));
            $data = $query->fetchAll();
            return isset($data[0]["CDFILIAL"]) ? $data[0]["CDFILIAL"] : null;
        } catch(\Exception $e) {
            throw $e;
        }
    }

    public function insertLista($nrlista, $cdlista) 
    {
        try {
            $sql = "INSERT INTO LISTA (NRLISTA, CDLISTA) VALUES (:NRLISTA, :CDLISTA)";
            $params = array(
                "NRLISTA" => $nrlista,
                "CDLISTA" => $cdlista
            );
            $this->entityManager->getConnection()->executeUpdate($sql, $params); 
        } catch(\Exception $e) {
            throw $e;
        }
    }
}