<?php
/**
 * Created by JetBrains PhpStorm.
 * User: victornovy
 * Date: 01/09/14
 * Time: 10:40
 * To change this template use File | Settings | File Templates.
 */

namespace Estoque\Logic\ManutencaoUltimoCusto;

use Estoque\Entities\Custocmpprod;
use \Geral\Util\DateUtil;
use Geral\Util\TratamentoDeMensagens;

class ManutencaoUltimoCusto {

    public static function formataData($data)
    {
        if (strlen($data) == 19)
            $data = DateUtil::truncateString($data);
        $data = DateUtil::getDataDeString($data);
        $data = DateUtil::truncateData($data);

        return $data;
    }

    public static function insertUltimoCusto(
        $filial, $almoxaridado, $localEstoque, $produto, $lote, $subLote, $ucCompraLiquida,
        $ucCompraBruta, $dataReferencia, $ucLiquidaIf1, $ucBrutaIf1, $ucLiquidaIf2, $ucBrutaIf2,
        $lancamento, $organizacao, $organizacaoInclusao, $organizacaoAlteracao, $operadorInclusao,
        $operadorAlteracao, $dataInclusao, $dataAtualizacao
    )
    {
        try {
            /** @var $ultimoCusto Custocmpprod */
            $ultimoCusto = new Custocmpprod();
            $ultimoCusto->setCdfilial($filial);
            $ultimoCusto->setCdalmoxarife($almoxaridado);
            $ultimoCusto->setCdlocalestoq($localEstoque);
            $ultimoCusto->setCdproduto($produto);
            $ultimoCusto->setNrloteestq($lote);
            $ultimoCusto->setNrsublote($subLote);
            $ultimoCusto->setVrliqcmpprod($ucCompraLiquida);
            $ultimoCusto->setVrbrucmpprod($ucCompraBruta);
            $ultimoCusto->setDtcustcmppro(self::formataData($dataReferencia));
            $ultimoCusto->setVrliqcmpprm1($ucLiquidaIf1);
            $ultimoCusto->setVrbrucmpprm1($ucBrutaIf1);
            $ultimoCusto->setVrliqcmpprm2($ucLiquidaIf2);
            $ultimoCusto->setVrbrucmpprm2($ucBrutaIf2);
            $ultimoCusto->setNrlancestq($lancamento);
            $ultimoCusto->setNrorg($organizacao);
            $ultimoCusto->setNrorginclusao($organizacaoInclusao);
            $ultimoCusto->setNrorgultatu($organizacaoAlteracao);
            $ultimoCusto->setCdoperinclusao($operadorInclusao);
            $ultimoCusto->setCdoperultatu($operadorAlteracao);
            $ultimoCusto->setDtinclusao(self::formataData($dataInclusao));
            $ultimoCusto->setDtultatu(self::formataData($dataAtualizacao));
            $ultimoCusto->persist();

            \Setforms2\Shared\Registry::getEntityManager()->flush();
        } catch (\Exception $e) {
            TratamentoDeMensagens::exibirMensagens($e, true);
        }
    }

    public static function updateUltimoCusto(
        $filial, $produto, $almoxarifado, $localEstoque, $dataReferencia, $ucCompraLiquida,
        $ucCompraBruta, $ucLiquidaIf1, $ucBrutaIf1, $ucLiquidaIf2, $ucBrutaIf2,
        $organizacaoAlteracao, $operadorAlteracao, $dataAtualizacao, $organizacao
    )
    {
        try {
            /** @var $ultimoCusto Custocmpprod */
            $ultimoCusto = Custocmpprod::findOneByCdfilialAndCdalmoxarifeAndCdlocalestoqAndCdprodutoAndDtcustcmpproAndNrorg(
                $filial, $almoxarifado, $localEstoque, $produto, self::formataData($dataReferencia), $organizacao
            );
            $ultimoCusto->setVrliqcmpprod($ucCompraLiquida);
            $ultimoCusto->setVrbrucmpprod($ucCompraBruta);
            $ultimoCusto->setVrliqcmpprm1($ucLiquidaIf1);
            $ultimoCusto->setVrbrucmpprm1($ucBrutaIf1);
            $ultimoCusto->setVrliqcmpprm2($ucLiquidaIf2);
            $ultimoCusto->setVrbrucmpprm2($ucBrutaIf2);
            $ultimoCusto->setNrorgultatu($organizacaoAlteracao);
            $ultimoCusto->setCdoperultatu($operadorAlteracao);
            $ultimoCusto->setDtultatu(self::formataData($dataAtualizacao));
            $ultimoCusto->persist();

            \Setforms2\Shared\Registry::getEntityManager()->flush();
        } catch (\Exception $e) {
            TratamentoDeMensagens::exibirMensagens($e, true);
        }
    }

    public static function deleteUltimoCusto(
        $filial, $almoxarifado, $localEstoque, $produto, $dataReferencia, $organizacao
    )
    {
        try {
            /** @var $ultimoCusto Custocmpprod */
            $ultimoCusto = Custocmpprod::findOneByCdfilialAndCdalmoxarifeAndCdlocalestoqAndCdprodutoAndDtcustcmpproAndNrorg(
                $filial, $almoxarifado, $localEstoque, $produto, self::formataData($dataReferencia), $organizacao
            );
            $ultimoCusto->delete();

            \Setforms2\Shared\Registry::getEntityManager()->flush();
        } catch (\Exception $e) {
            TratamentoDeMensagens::exibirMensagens($e, true);
        }
    }
}