<?php
/**
 * Namespace Geral\Entities
 *
 * PHP version 5
 *
 * @category Php
 * @package  Geral\Entities
 * @author   andreteixeira <andre.teixeira@teknisa.com>
 * @license  www.teknisa.com Teknisa
 * @link     http://localhost:9090/tecfood
 */
namespace Geral\Entities;

/**
 * Class Subgrupprod
 *
 * PHP version 5
 *
 * @category Php
 * @package  Geral\Entities
 * @author   andreteixeira <andre.teixeira@teknisa.com>
 * @license  www.teknisa.com Teknisa
 * @link     http://localhost:9090/tecfood
 */
class Subgrupprod extends Base\Subgrupprod
{

    /**
     * Seta os campos do registro existente ou cria um novo registro.
     *
     * @param String $nrorg           Organização
     * @param String $cdgrupprod      Código do Grupo
     * @param String $cdsubgrprod     Código do Subgrupo
     * @param String $nmsubgrprod     Nome do Subgrupo
     * @param String $nrorginclusao   Organização Inclusao
     * @param String $cdoperinclusao  Operador Inclusao
     * @param String $dtinclusao      Data Inclusao
     * @param String $nrorgultatu     Organização
     * @param String $dtultatu        Data Atualização
     * @param String $dtultatusugp    Data Atualização
     * @param String $cdoperultatu    Operador Atualização
     * @param String $idverestolanenc Idverestolanenc
     * @param String $idverestolanore Idverestolanore
     *
     * @return null
     */
    public static function setCamposRegistro (
        $nrorg, $cdgrupprod, $cdsubgrprod, $nmsubgrprod,
        $nrorginclusao, $cdoperinclusao, $dtinclusao, $nrorgultatu,
        $dtultatu, $dtultatusugp, $cdoperultatu, $idverestolanenc,
        $idverestolanore
    ) {
        $subgrupprod = self::buscaRegistro(
            $nrorg, $cdgrupprod, $cdsubgrprod
        );
        if (!($subgrupprod instanceof self)) {
            $subgrupprod = new self();
            $subgrupprod->setCdgrupprod($cdgrupprod);
            $subgrupprod->setCdsubgrprod($cdsubgrprod);
            $subgrupprod->setNrorg($nrorg);
            $subgrupprod->setNrorginclusao($nrorginclusao);
            $subgrupprod->setDtinclusao($dtinclusao);
            $subgrupprod->setCdoperinclusao($cdoperinclusao);
        }
        $subgrupprod->setNmsubgrprod($nmsubgrprod);
        $subgrupprod->setNrorgultatu($nrorgultatu);
        $subgrupprod->setDtultatu($dtultatu);
        $subgrupprod->setDtultatusugp($dtultatusugp);
        $subgrupprod->setCdoperultatu($cdoperultatu);
        $subgrupprod->setIdverestolanenc($idverestolanenc);
        $subgrupprod->setIdverestolanore($idverestolanore);
        $subgrupprod->setIdimqtrelore('N');
        $subgrupprod->setIdimpdevolacfi('N');
        $subgrupprod->setIddescontosbgr('N');
        $subgrupprod->setIddifefretesbgr('N');
        $subgrupprod->setIdutsbgrcalimit('N');
        $subgrupprod->setIdfretesbgr('N');
        $subgrupprod->persist();
    }

    /**
     * Busca Registro
     *
     * @param String $nrorg       Organização
     * @param String $cdgrupprod  Código do Grupo
     * @param String $cdsubgrprod Código do Subgrupo
     *
     * @return bool.
     */
    public static function buscaRegistro ($nrorg, $cdgrupprod, $cdsubgrprod)
    {
        return self::getObjectByWhere(
            "NRORG = ? AND CDGRUPPROD = ? AND CDSUBGRPROD = ?",
            array($nrorg, $cdgrupprod, $cdsubgrprod)
        );
    }

}