-- ================================================================================
--   DATABASE NAME : COMISSARIA                                                  --
--   CRIADO EM     : 08/07/99                                                    --
--   CRIACAO       : ROBERT,LUCIANA CORREA                                       --
--   RESPONSAVEL   : COMISSARIA                                                  --
--   MANUTENCOES   :                                                             --
--                   10/07/2001 - LUCIANA CORREA - MULTI-EMPRESA                 --
--  @C:\WIN_PRJ\SQL\ORACLE\2707_ATESTP_RETORNACICLOSERV.SQL                      --
-- ================================================================================

CREATE OR REPLACE PROCEDURE RETORNA_CICLO(
  P_CDFILIAL     IN     FILIAL.CDFILIAL%TYPE,
  P_CDCIA        IN     COMPANHIA.CDCIA%TYPE,
  P_NRVOO        IN     VOO.NRVOO%TYPE,
  P_CDTRECHO     IN     VOOTRECHO.CDTRECHO%TYPE,
  P_DTHRPLAVOOPV IN     PLANOVOO.DTHRPLAVOOPV%TYPE,
  P_CDSERVICO    IN     SERVICOCIA.CDSERVICO%TYPE,
  P_CDCLASSE     IN     CLASSE.CDCLASSE%TYPE,
  P_CDCICLO_GER  IN OUT CICLOCIA.CDCICLO%TYPE
)

AS

  V_EXISTECICLO   NUMBER;
  V_EXISTECIA     NUMBER;
  V_CDCICLO       CICLOCIA.CDCICLO%TYPE;
  V_CDCICLO_UNICO CICLOCIA.CDCICLO%TYPE;
  V_SGCIA         COMPANHIA.SGCIA%TYPE;

BEGIN
  V_CDCICLO     := P_CDCICLO_GER;
  P_CDCICLO_GER := NULL;
  SELECT COUNT(CDSERVICO)
  INTO   V_EXISTECICLO
  FROM   FRCICLOSER
  WHERE (CDFILIAL   = P_CDFILIAL    ) AND
        (CDCIA      = P_CDCIA       ) AND
        (NRVOO      = P_NRVOO       ) AND
        (CDTRECHO   = P_CDTRECHO    ) AND
        (CDSERVICO  = P_CDSERVICO   ) AND
        /*(CDCLASSE   = P_CDCLASSE    ) AND*/
        (DTCICLOSER = P_DTHRPLAVOOPV);

  IF (V_EXISTECICLO <> 0) THEN
    P_CDCICLO_GER := V_CDCICLO;
  END IF;

  /* SE SERVIO NO POSSUI CICLO ESPECFICO BUSCA POR CLASSE */
  IF (V_EXISTECICLO = 0) THEN
    SELECT COUNT(CDCICLO)
    INTO   V_EXISTECICLO
    FROM   FRCICLOVCLA
    WHERE (CDFILIAL    = P_CDFILIAL) AND
          (CDCIA       = P_CDCIA   ) AND
          (NRVOO       = P_NRVOO   ) AND
          (CDTRECHO    = P_CDTRECHO) AND
          (CDCLASSE    = P_CDCLASSE) AND
          (DTCICLOVCLA = P_DTHRPLAVOOPV);
    IF (V_EXISTECICLO <> 0) THEN
      SELECT CDCICLO
      INTO   P_CDCICLO_GER
      FROM   FRCICLOVCLA
      WHERE (CDFILIAL    = P_CDFILIAL) AND
            (CDCIA       = P_CDCIA   ) AND
            (NRVOO       = P_NRVOO   ) AND
            (CDTRECHO    = P_CDTRECHO) AND
            (CDCLASSE    = P_CDCLASSE) AND
            (DTCICLOVCLA = P_DTHRPLAVOOPV);
    ELSE
      SELECT COUNT(CDCICLO)
      INTO   V_EXISTECICLO
      FROM   FRCICLOVOO
      WHERE (CDFILIAL   = P_CDFILIAL) AND
            (CDCIA      = P_CDCIA   ) AND
            (NRVOO      = P_NRVOO   ) AND
            (CDTRECHO   = P_CDTRECHO) AND
            (DTCICLOVOO = P_DTHRPLAVOOPV);
      IF (V_EXISTECICLO <> 0) THEN
        SELECT CDCICLO
        INTO   P_CDCICLO_GER
        FROM   FRCICLOVOO
        WHERE (CDFILIAL   = P_CDFILIAL) AND
              (CDCIA      = P_CDCIA   ) AND
              (NRVOO      = P_NRVOO   ) AND
              (CDTRECHO   = P_CDTRECHO) AND
              (DTCICLOVOO = P_DTHRPLAVOOPV);
      ELSE
        SELECT COUNT(CDCICLO)
        INTO   V_EXISTECICLO
        FROM   FRCICLOCIA
        WHERE (CDFILIAL   = P_CDFILIAL) AND
              (CDCIA      = P_CDCIA   ) AND
              (DTCICLOCIA = P_DTHRPLAVOOPV);
        IF (V_EXISTECICLO <> 0) THEN
          SELECT CDCICLO
          INTO   P_CDCICLO_GER
          FROM   FRCICLOCIA
          WHERE (CDFILIAL   = P_CDFILIAL) AND
                (CDCIA      = P_CDCIA   ) AND
                (DTCICLOCIA = P_DTHRPLAVOOPV);
        END IF;
      END IF;
    END IF;
  END IF;

  IF P_CDCICLO_GER IS NULL THEN
    SELECT COUNT(CDCIA)
    INTO   V_EXISTECIA
    FROM   CIAFILI
    WHERE  CDFILIAL = P_CDFILIAL AND
           CDCIA    = P_CDCIA;
    IF (V_EXISTECIA <> 0) THEN
      SELECT CO.SGCIA,CF.CDCICLO
      INTO   V_SGCIA, V_CDCICLO_UNICO
      FROM   CIAFILI CF ,COMPANHIA CO
      WHERE  CF.CDFILIAL = P_CDFILIAL AND
             CF.CDCIA    = P_CDCIA    AND
             CF.CDCIA    = CO.CDCIA;
    END IF;
    IF V_CDCICLO_UNICO IS NULL THEN
       Raise_Application_Error(-20501, '#Evoo_Ciclo'||'     '|| V_SGCIA ||'*', True);
       /* 'Gerao interrompida. Falta ciclo para esta data para a companhia '|| V_SGCIA ||
         '. Verifique a opo Frequncia de Ciclo para esta companhia ou cadastre um ciclo nico e tente novamente', True);*/
    ELSE
      P_CDCICLO_GER := V_CDCICLO_UNICO;
    END IF;
  END IF;
END;
/


-- VERSAO --
BEGIN ATUVEROBJ('RETORNA_CICLO','4.07.141'); END;
/

